{=======================================================}
{                                                       }
{     <<Mirro For Delphi>> Intenet Demo  Send         }
{                                                       }
{        (c)Copyright 2005,www.138soft.com              }
{                                                       }
{=======================================================}

unit USend;

{=======================================================
  Project : <Mirro For Delphi>> Intenet Demo  Send
  Module  : Main Form
  Describe: (None)
  Version : 1.0
  Data    : 2005-11-12
  Author  : Chen JingTao,http://www.138soft.com,lovejingtao@21cn.com
  Update  : 2005-11-12
=======================================================}

interface

uses
  Windows, Messages, SysUtils, Jpeg, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdAntiFreezeBase, IdAntiFreeze, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    StatusBar1: TStatusBar;
    IdTCPClient1: TIdTCPClient;
    IdAntiFreeze1: TIdAntiFreeze;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  iWidth, iHeight: integer;
  iColor: integer = 24;
  hCaptureThread: THandle = 0;
  bStart: BOOL = False;
  bFirst: Bool = True;
  MyBmp: TBitmap;
  MyJpg: TJPEGImage;
  MyStream: TMemoryStream;
  BmpFileHeader: TBitmapFileHeader;
  BmpInfo: TBitmapInfoHeader;

implementation

uses
  Mirro_D7, UCommon, IdGlobal{For the EOL};

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  if not InstallMirroDriver then
  begin
    ShowMessage('Mirro Driver Init Err!');
    Application.Terminate;
    Exit;
  end;
  MyBmp := TBitmap.Create;
  MyJpg := TJPEGImage.Create;
  MyStream := TMemoryStream.Create;
  FillChar(BmpInfo, SizeOf(TBitmapInfoHeader), 0);
  with BmpInfo do
  begin
    biSize := SizeOf(TBitmapInfoHeader);
    biPlanes := 1;
    biBitCount := 24;
    biCompression := BI_RGB;
  end;

  FillChar(BmpFileHeader, Sizeof(TBitmapfileheader), 0);
  with BmpFileHeader do
  begin
    bfType := $4D42;
    bfOffBits := Sizeof(TBitmapFileHeader) + Sizeof(TBitmapInfoHeader);
    bfReserved1 := 0;
    bfReserved2 := 0;
  end;
end;

function MirroCaptureThread(lpParam: Pointer): DWORD; stdcall;
var
  pBmpBuf: PByte;
  dwType: DWORD;
  MyRect: TRect;
  iBmpWidth, iBmpHeight, iBmpSize: integer;
  iNewWidth, iNewHeight: integer;
begin
  Result := 0;

  pBmpBuf := GetMemory(iWidth * iHeight * iColor div 8);
  if pBmpBuf = nil then
  begin
    ShowMessage('Alloc Memory Error!');
    Exit;
  end;

  while (bStart and (Form1.IdTCPClient1.Connected)) do
  begin
    if bFirst then
    begin
      bFirst := False;
      dwType := MirrorGetFullScreen(@MyRect, pBmpBuf);
    end
    else
      dwType := MirrorGetChangeInfo(@MyRect, pBmpBuf);

    if dwType = CHANGE_NO then
    begin
      Sleep(20);
      Continue;
    end
    else if dwType = CHANGE_SCREEN then
    begin
      iBmpWidth := MyRect.Right - MyRect.Left;
      iBmpHeight := MyRect.Bottom - MyRect.Top;
      iBmpSize := iBmpWidth * iBmpHeight * iColor div 8;

      //Conver the bmp===>jpg,and you can use Other compress......
      BmpInfo.biWidth := iBmpWidth;
      BmpInfo.biHeight := -iBmpHeight;
      BmpFileHeader.bfSize := iBmpSize;
      MyStream.Clear;
      MyStream.Write(BmpFileHeader, Sizeof(TBitmapfileheader));
      MyStream.Write(BmpInfo, SizeOf(TBitmapInfoHeader));
      MyStream.Write(pBmpBuf^, iBmpSize);
      MyStream.Position := 0;
      MyBmp.LoadFromStream(MyStream);
      MyJpg.Assign(MyBmp);
      MyJpg.CompressionQuality := 65;
      MyStream.Clear;
      MyJpg.SaveToStream(MyStream);
      MyStream.Position := 0;

      try
        Form1.IdTCPClient1.Write(COMMAND_DATA + EOL + EOL);
        Form1.IdTCPClient1.WriteInteger(MyRect.Left);
        Form1.IdTCPClient1.WriteInteger(MyRect.Top);
        Form1.IdTCPClient1.WriteInteger(MyRect.Right);
        Form1.IdTCPClient1.WriteInteger(MyRect.Bottom);
        Form1.IdTCPClient1.WriteInteger(MyStream.Size);
        Form1.IdTCPClient1.WriteStream(MyStream);
      except
        MirrorStop;
        Form1.Button1.Enabled := True;
        Application.Restore;
        SetForegroundWindow(Form1.Handle);
        break;
      end;
    end
    else if dwType = CHANGE_EXIT then
    begin
      if (MirrorStart(SCREEN_COLOR_24, @iNewWidth, @iNewHeight, False) <> 0) then
      begin
        ShowMessage('Mirro Driver Init Err!');
        break;
      end;

      if (iNewWidth * iNewHeight * 24 > iWidth * iHeight * iColor) then
      begin
        iWidth := iNewWidth;
        iHeight := iNewHeight;
        iColor := 24;
        if (pBmpBuf <> nil) then
        begin
          FreeMemory(pBmpBuf);
          pBmpBuf := nil;
        end;
        pBmpBuf := GetMemory(iWidth * iHeight * iColor div 8);
        if (pBmpBuf = nil) then
        begin
          ShowMessage('Alloc Memory Error!');
          break;
        end;
      end;

    end;
  end; //end while


  if (pBmpBuf <> nil) then
  begin
    FreeMemory(pBmpBuf);
    pBmpBuf := nil;
  end;

  hCaptureThread := 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  dwResult, id: DWORD;
begin
  if Trim(Edit1.Text) = '' then
  begin
    ShowMessage('Please Input the Recv IP!');
    Edit1.SetFocus;
    Exit;
  end;
  try
    IdTCPClient1.Host := Edit1.Text;
    IdTCPClient1.Port := iTcpPort;
    IdTCPClient1.Connect(1000 * 3);
  except
    IdTCPClient1.Disconnect;
    ShowMessage('Connect Err!');
    Exit;
  end;
  dwResult := MirrorStart(SCREEN_COLOR_24, @iWidth, @iHeight, False);
  if (dwResult <> 0) then
  begin
    ShowMessage(Format('Load Driver Err.ErrCode:0x%X', [dwResult]));
    Exit;
  end;
  hCaptureThread := CreateThread(nil, 0, @MirroCaptureThread, nil, 0, id);
  if hCaptureThread = 0 then
  begin
    dwResult := GetLastError();
    MirrorStop;
    ShowMessage(Format('Start Thread Err.ErrCode:%X', [dwResult]));
    Exit;
  end;
  bStart := TRUE;
  Button1.Enabled := False;
  Application.Minimize;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  bStart := FALSE;
  if (hCaptureThread <> 0) then
  begin
    WaitForSingleObject(hCaptureThread, INFINITE);
    CloseHandle(hCaptureThread);
    hCaptureThread := 0;
  end;
  MyBmp.Free;
  MyJpg.Free;
  MyStream.Free;
  MirrorStop;
end;

end.

