{=======================================================}
{                                                       }
{     <<Mirro For Delphi>>  Demo  Local Display       }
{                                                       }
{        (c)Copyright 2005,www.138soft.com              }
{                                                       }
{=======================================================}

unit UDemo;

{=======================================================
  Project : <Mirro For Delphi>>  Demo  Local Display
  Module  : Main Form
  Describe: (None)
  Version : 1.0
  Data    : 2005-11-12
  Author  : Chen JingTao,http://www.138soft.com,lovejingtao@21cn.com
  Update  : 2005-11-12
=======================================================}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  iWidth, iHeight: integer;
  iColor: integer = 24; 
  hCaptureThread: THandle = 0;
  bStart: BOOL = False;
  bFirst:Bool=True;

implementation

uses
  Mirro_D7;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  if not InstallMirroDriver then
  begin
    ShowMessage('Mirro Driver Init Err!');
    Application.Terminate;
    Exit;
  end;
end;

function MirroCaptureThread(lpParam: Pointer): DWORD; stdcall;
var
  pBmpBuf: PByte;
  dwType: DWORD;
  MyRect: TRect;
  iBmpWidth, iBmpHeight, iBmpSize: integer;
  iNewWidth, iNewHeight: integer;
  dc:HDC;
  BitmapInfo:TBitmapInfo;
begin
  Result := 0;

  pBmpBuf := GetMemory(iWidth * iHeight * iColor div 8);
  if pBmpBuf = nil then
  begin
    ShowMessage('Alloc Memory Error!');
    Exit;
  end;

  while bStart do
  begin
    if bFirst then
    begin
    bFirst:=False;
    dwType := MirrorGetFullScreen(@MyRect, pBmpBuf);
    end
    else
    dwType := MirrorGetChangeInfo(@MyRect, pBmpBuf);

    if dwType = CHANGE_NO then
    begin
      Sleep(20);
      Continue;
    end
    else if dwType = CHANGE_SCREEN then
    begin
      iBmpWidth := MyRect.Right - MyRect.Left;
      iBmpHeight := MyRect.Bottom - MyRect.Top;
      iBmpSize := iBmpWidth * iBmpHeight * iColor div 8;
      dc:=GetDC(Form1.Handle);
      FillChar(BitmapInfo,sizeof(TBitmapInfo),0);
      FillChar(BitmapInfo.bmiHeader,sizeof(TBitmapInfoHeader),0);
       with BitmapInfo.bmiHeader do
      begin
        biSize := SizeOf(TBitmapInfoHeader);
        biWidth := iBmpWidth;
        biHeight := -iBmpHeight;
        biPlanes := 1;
        biBitCount := 24;
        biCompression := BI_RGB;
      end;
       {
           StretchDIBits(dc,
                        MyRect.Left,
                        MyRect.Top,
                        iBmpWidth,
                        iBmpHeight,
                        0,
                        0,
                        iBmpWidth,
                        iBmpHeight,
                        pBmpBuf,
                        BitmapInfo,
                        DIB_RGB_COLORS,
                        SRCCOPY);
      }
      SetDIBitsToDevice(dc,
                        MyRect.Left,
                        MyRect.Top,
                        iBmpWidth,
                        iBmpHeight,
                        0,
                        0,
                        0,
                        iBmpHeight,
                        pBmpBuf,
                        BitmapInfo,
                        DIB_RGB_COLORS);
      ReleaseDC(0,dc);
     // InvalidateRect(Form1.Handle,@MyRect, FALSE);
    end
    else if dwType = CHANGE_EXIT then
    begin
    
      if (MirrorStart(SCREEN_COLOR_24, @iNewWidth, @iNewHeight, False) <> 0) then
      begin
        ShowMessage('Mirro Driver Init Err!');
        break;
      end;

      if (iNewWidth * iNewHeight * 24 > iWidth * iHeight * iColor) then
      begin
        iWidth := iNewWidth;
        iHeight := iNewHeight;
        iColor := 24;
        if (pBmpBuf <> nil) then
        begin
          FreeMemory(pBmpBuf);
          pBmpBuf := nil;
        end;
        pBmpBuf := GetMemory(iWidth * iHeight * iColor div 8);
        if (pBmpBuf = nil) then
        begin
          ShowMessage('Alloc Memory Error!');
          break;
        end;
      end;

    end;
  end; //end while


  if (pBmpBuf <> nil) then
  begin
    FreeMemory(pBmpBuf);
    pBmpBuf := nil;
  end;

  hCaptureThread := 0;
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  dwResult, id: DWORD;
begin
  OnActivate:=nil;
  dwResult := MirrorStart(SCREEN_COLOR_24, @iWidth, @iHeight, False);
  if (dwResult <> 0) then
  begin
    ShowMessage(Format('Load Driver Err.ErrCode:0x%X', [dwResult]));
    Exit;
  end;
  hCaptureThread := CreateThread(nil, 0, @MirroCaptureThread, nil, 0, id);
  if hCaptureThread = 0 then
  begin
    dwResult := GetLastError();
    MirrorStop;
    ShowMessage(Format('Start Thread Err.ErrCode:%X', [dwResult]));
    Exit;
  end;
  bStart := TRUE;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  bStart := FALSE;
  if (hCaptureThread <> 0) then
  begin
    WaitForSingleObject(hCaptureThread, INFINITE);
    CloseHandle(hCaptureThread);
    hCaptureThread := 0;
  end;
  MirrorStop;
end;
end.

 